package net.locusworks.test;

import static org.junit.Assert.*;

import org.junit.Test;

import net.locusworks.common.immutables.Pair;
import net.locusworks.common.immutables.Triplet;
import net.locusworks.common.immutables.Unit;


public class ImmutablesTest {

  @Test
  public void testUnit() {
    Unit<String> unit = new Unit<>("Hello World");
    assertTrue(unit.getValue1().equals("Hello World"));
    Unit<Integer> unit2 = new Unit<>(2);
    assertTrue(unit2.getValue1().equals(2));
  }
  
  @Test
  public void testPair() {
    Pair<String, String> pair1 = new Pair<>("Hello", "World");
    assertTrue(pair1.getValue1().equals("Hello"));
    assertTrue(pair1.getValue2().equals("World"));
    
    Pair<String, Integer> pair2 = new Pair<>("Foo", 25);
    assertTrue(pair2.getValue1().equals("Foo"));
    assertTrue(pair2.getValue2().equals(25));
    
    Pair<Integer, Integer> pair3 = new Pair<>(1, 23);
    assertTrue(pair3.getValue1().equals(1));
    assertTrue(pair3.getValue2().equals(23));
  }
  
  @Test
  public void testTriplet() {
    Triplet<String, Integer, String> triplet1 = new Triplet<>("Hello", 24, "World");
    assertTrue(triplet1.getValue1().equals("Hello"));
    assertTrue(triplet1.getValue2().equals(24));
    assertTrue(triplet1.getValue3().equals("World"));
  }

}
